## fuse 2.9.9-8.1build1trisquel1

=== debian/changelog ===
fuse (2.9.9-8.1build1trisquel1) ecne; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 07 Oct 2024 16:54:07 +0000

fuse (2.9.9-8.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:27:22 +0000

fuse (2.9.9-8.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition. (Closes: #1062089)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 01 Mar 2024 11:24:20 +1300

fuse (2.9.9-8) unstable; urgency=medium

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Fix /dev/fd/N support to handle the absence of a mountpoint.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 07 Nov 2023 06:58:07 +0100

fuse (2.9.9-7) unstable; urgency=medium

  * Use no for Rules-Requires-Root.
  * Update Standards-Version to 4.6.2 .

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Cover libfuse2-udeb with the noudeb build profile (closes: #1024926).
  * Backport support for /dev/fd/N (closes: #1055222).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 05 Nov 2023 13:44:31 +0100

fuse (2.9.9-6) unstable; urgency=medium

  * Disable link time optimization (closes: #1015408).
  * Update Lintian overrides.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.6.1 .

  [ Adrian Bunk <bunk@debian.org> ]
  * Add upstream fix for FTBFS with glibc 2.34 (closes: #1017154).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 16 Oct 2022 14:24:16 +0200

=== debian/control ===
Source: fuse
Section: utils
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libselinux-dev [linux-any],
 gettext
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/libfuse/libfuse/wiki

Package: fuse
Section: utils
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfuse2t64 (= ${binary:Version}),
 adduser,
 mount (>= 2.19.1),
 sed (>= 4)
Description: Filesystem in Userspace
 Filesystem in Userspace (FUSE) is a simple interface for userspace programs to
 export a virtual filesystem to the Linux kernel. It also aims to provide a
 secure method for non privileged users to create and mount their own filesystem
 implementations.

Package: libfuse2t64
Provides: ${t64:Provides}
Replaces: libfuse2
Breaks: libfuse2 (<< ${source:Version})
Section: libs
Architecture: linux-any kfreebsd-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts: fuse (<< ${binary:Version})
Suggests: fuse
Description: Filesystem in Userspace (library)
 Filesystem in Userspace (FUSE) is a simple interface for userspace programs to
 export a virtual filesystem to the Linux kernel. It also aims to provide a
 secure method for non privileged users to create and mount their own filesystem
 implementations.
 .
 This package contains the shared library.

Package: libfuse-dev
Section: libdevel
Architecture: linux-any kfreebsd-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libfuse2t64 (= ${binary:Version}),
 libselinux-dev [linux-any],
Suggests: fuse
Description: Filesystem in Userspace (development)
 Filesystem in Userspace (FUSE) is a simple interface for userspace programs to
 export a virtual filesystem to the Linux kernel. It also aims to provide a
 secure method for non privileged users to create and mount their own filesystem
 implementations.
 .
 This package contains the development files.

Package: fuse-udeb
Package-Type: udeb
Build-Profiles: <!noudeb>
Architecture: linux-any
Section: debian-installer
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfuse2-udeb (= ${binary:Version}),
Description: Filesystem in Userspace

Package: libfuse2-udeb
Package-Type: udeb
Build-Profiles: <!noudeb>
Architecture: linux-any kfreebsd-any
Section: debian-installer
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Filesystem in Userspace (library)

## fuse 2.9.9.1

=== debian/changelog ===
fuse (2.9.9.1-1+dde) unstable; urgency=medium

  * fix fill_dir crash when name is NULL
  * add lintian overrides: source-is-missing

 -- wangrong <wangrong@uniontech.com>  Fri, 13 May 2022 13:13:03 +0800

## fuse makefiles

=== Makefile ===


.EXPORT_ALL_VARIABLES:

DIRS = lib util kernel
# example

# should always be set.
CFLAGS += -D_FILE_OFFSET_BITS=64
CFLAGS += -D_REENTRANT

CFLAGS += -DUSE_UCLIBC
#CFLAGS += -DUCLIBC_HAS_MMU
CFLAGS += -DEMBEDDED
CFLAGS += -D_GNU_SOURCE

all romfs install:
	for i in $(DIRS) ; do make -C $$i $@ || exit $?; done

clean:
	for i in $(DIRS) ; do make -C $$i clean ; done

=== kernel/Makefile ===

EXECS = fuse.o fuse.ko
OBJS = dev.o dir.o file.o inode.o util.o

all: KERNEL_VERSION $(EXECS)

CFLAGS = -fno-builtin -nostdinc -D__uClinux__ -D__KERNEL__ -I${ROOTDIR}/${CONFIG_LINUXDIR}/include -Wall -Wstrict-prototypes -Wno-trigraphs -O1 -fno-strict-aliasing -fno-common -I$(GCC_DIR)/include -pipe -DNO_MM -DNO_FPU $(CPUFLAGS) -Wa,-S -Wa,$(CPUFLAGS) -DUTS_SYSNAME="uClinux" -D__linux__ -DMODULE  -nostdinc -iwithprefix include
CFLAGS += -DFUSE_VERSION=\"1.1\"

#VERSION = 2
#PATCHLEVEL = 4
#SUBLEVEL = 20
#CFLAGS = -D__KERNEL__ -I${LINUXDIR}/include -Wall -Wstrict-prototypes -Wno-trigraphs -O2 -fno-strict-aliasing -fno-common -fomit-frame-pointer -I${LINUXDIR}/../../include -I ${LINUXDIR}/include/asm/gcc -G 0 -mno-abicalls -fno-pic -pipe -mcpu=r4600 -mips2 -Wa,--trap  -m4710a0kern   -nostdinc -iwithprefix include -DMODULE -mlong-calls -fno-common


CFLAGS += -I../include
CFLAGS += -D_FILE_OFFSET_BITS=64

LDFLAGS = -r

KERNEL_VERSION:
	sed -n -e 's/^\([A-Z]*\)\ =\ \([0-9]*\)$$/\1=\2/p' -e 's/^\([A-Z]*\)\ =\ \(-[-a-z0-9]*\)$$/\1=\2/p' ${ROOTDIR}/${CONFIG_LINUXDIR}/Makefile > KERNEL_VERSION

COMPOBJ = compat/parser.o

fuse.o: KERNEL_VERSION $(OBJS) $(COMPOBJ)
	# ugly way to set kernel version variables
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(COMPOBJ)

-include KERNEL_VERSION

ifeq ($(strip $(PATCHLEVEL)),6) && ($(strip $(VERSION)),2)
CFLAGS += -DKBUILD_MODNAME=fuse
OBJMOD = fuse.mod.o
else
# romptr not valid for 2.6.x
CFLAGS += -DMAGIC_ROM_PTR
OBJMOD = 
endif

fuse.ko: $(OBJS) $(OBJMOD)
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJMOD)

romfs:
	mkdir -p ${ROMFSDIR}/lib/modules/${VERSION}.${PATCHLEVEL}.${SUBLEVEL}${EXTRAVERSION}
ifeq ($(strip $(PATCHLEVEL)),6) && ($(strip $(VERSION)),2)
	$(ROMFSINST) /lib/modules/${VERSION}.${PATCHLEVEL}.${SUBLEVEL}${EXTRAVERSION}/fuse.ko
else
	$(ROMFSINST) /lib/modules/${VERSION}.${PATCHLEVEL}.${SUBLEVEL}${EXTRAVERSION}/fuse.o
endif

install:
	install -d $(INSTALLDIR)/lib/modules/$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)
	install fuse.o $(INSTALLDIR)/lib/modules/$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)/fuse.o

clean:
	rm -f $(EXECS) *~ *.gdb *.elf *.o *.ko *.s *.i KERNEL_VERSION $(COMPOBJ)

=== lib/Makefile ===

EXEC = libfuse.a
OBJS = fuse.o fuse_mt.o helper.o mount.o

# macros and variables
RANLIB = $(CROSS)ranlib

all: $(EXEC)

CFLAGS += -Wall -I../include

FLTFLAGS = -s 32000

$(EXEC): $(OBJS)
	rm -f $(EXEC)
	$(CROSS)ar cr $(EXEC) $(OBJS)

romfs:

install:

clean:
	rm -f $(EXEC) *.gdb *.elf *.o *.s *.i

## fuse makefiles-2.1

=== Makefile ===
--- 
+++ 
@@ -8,6 +8,7 @@
 # should always be set.
 CFLAGS += -D_FILE_OFFSET_BITS=64
 CFLAGS += -D_REENTRANT
+CFLAGS += -DFUSE_DIRFIL_COMPAT
 
 CFLAGS += -DUSE_UCLIBC
 #CFLAGS += -DUCLIBC_HAS_MMU

=== kernel/Makefile ===
--- 
+++ 
@@ -5,21 +5,24 @@
 all: KERNEL_VERSION $(EXECS)
 
 CFLAGS = -fno-builtin -nostdinc -D__uClinux__ -D__KERNEL__ -I${ROOTDIR}/${CONFIG_LINUXDIR}/include -Wall -Wstrict-prototypes -Wno-trigraphs -O1 -fno-strict-aliasing -fno-common -I$(GCC_DIR)/include -pipe -DNO_MM -DNO_FPU $(CPUFLAGS) -Wa,-S -Wa,$(CPUFLAGS) -DUTS_SYSNAME="uClinux" -D__linux__ -DMODULE  -nostdinc -iwithprefix include
-CFLAGS += -DFUSE_VERSION=\"1.1\"
+CFLAGS += -DFUSE_VERSION=\"2.1\"
 
 #VERSION = 2
 #PATCHLEVEL = 4
 #SUBLEVEL = 20
+#EXTRAVERSION = .1-uc0
 #CFLAGS = -D__KERNEL__ -I${LINUXDIR}/include -Wall -Wstrict-prototypes -Wno-trigraphs -O2 -fno-strict-aliasing -fno-common -fomit-frame-pointer -I${LINUXDIR}/../../include -I ${LINUXDIR}/include/asm/gcc -G 0 -mno-abicalls -fno-pic -pipe -mcpu=r4600 -mips2 -Wa,--trap  -m4710a0kern   -nostdinc -iwithprefix include -DMODULE -mlong-calls -fno-common
 
 
 CFLAGS += -I../include
 CFLAGS += -D_FILE_OFFSET_BITS=64
+CFLAGS += -DEMBEDDED
+CFLAGS += -DFUSE_DIRFIL_COMPAT
 
 LDFLAGS = -r
 
 KERNEL_VERSION:
-	sed -n -e 's/^\([A-Z]*\)\ =\ \([0-9]*\)$$/\1=\2/p' -e 's/^\([A-Z]*\)\ =\ \(-[-a-z0-9]*\)$$/\1=\2/p' ${ROOTDIR}/${CONFIG_LINUXDIR}/Makefile > KERNEL_VERSION
+	sed -n -e 's/^\([A-Z]*\)\ =\ \([-0-9.A-Za-z]*\)$$/\1=\2/p' -e 's/^\([A-Z]*\)\ =\ \(-[-a-z0-9]*\)$$/\1=\2/p' ${ROOTDIR}/${CONFIG_LINUXDIR}/Makefile > KERNEL_VERSION
 
 COMPOBJ = compat/parser.o

## fuse makefiles-2.3

=== Makefile ===


.EXPORT_ALL_VARIABLES:

DIRS = kernel lib util
# example

# should always be set.
CFLAGS += -D_FILE_OFFSET_BITS=64
CFLAGS += -D_REENTRANT
CFLAGS += -DFUSE_USE_VERSION=22

CFLAGS += -DUSE_UCLIBC
#CFLAGS += -DUCLIBC_HAS_MMU
CFLAGS += -D_GNU_SOURCE

CFLAGS += -Wall

#LIBFUSE_SHARED=1
#LIBFUSE_ID=2

all romfs install:
	for i in $(DIRS) ; do make -C $$i $@ || exit $?; done

clean:
	for i in $(DIRS) ; do make -C $$i clean ; done

=== example/Makefile ===

EXECS = hello fusexmp hello_mt
OBJS = hello.o fusexmp.o hello_mt.o

all: $(EXECS)

CFLAGS += -Wall -I../include
FUSELIBS += ../lib/libfuse.a

FLTFLAGS = -s 32000
#FLTFLAGS += -v

fusexmp: fusexmp.o
	$(CC) $(LDFLAGS) -o fusexmp fusexmp.o $(FUSELIBS) $(LIBPTHREAD) $(LDLIBS)

hello: hello.o
	$(CC) $(LDFLAGS) -o hello hello.o $(FUSELIBS) $(LIBPTHREAD) $(LDLIBS)

hello_mt: hello_mt.o
	$(CC) $(LDFLAGS) -o hello_mt hello_mt.o $(FUSELIBS) $(LIBPTHREAD) $(LDLIBS)

romfs:
	$(ROMFSINST) /usr/bin/hello
	$(ROMFSINST) /usr/bin/hello_mt
	$(ROMFSINST) /usr/bin/fusexmp

clean:
	rm -f $(EXECS) *.gdb *.elf *.o

=== kernel/Makefile ===

EXECS = fuse.o fuse.ko
OBJS = dev.o dir.o file.o inode.o

all: $(EXECS)

ifdef CONFIG_LINUXDIR
VERSION := $(shell sed -n -e 's/^\([A-Z]*\)\ =\ \([-0-9.A-Za-z]*\)$$/\1=\2/p' -e 's/^\([A-Z]*\)\ =\ \(-[-a-z0-9]*\)$$/\1=\2/p' ${ROOTDIR}/${CONFIG_LINUXDIR}/Makefile | grep VERSION)
PATCHLEVEL := $(shell sed -n -e 's/^\([A-Z]*\)\ =\ \([-0-9.A-Za-z]*\)$$/\1=\2/p' -e 's/^\([A-Z]*\)\ =\ \(-[-a-z0-9]*\)$$/\1=\2/p' ${ROOTDIR}/${CONFIG_LINUXDIR}/Makefile | grep PATCHLEVEL)
RELEASE := $(shell awk -F \" '/[ 	]*\#[ 	]*define[ 	]*UTS_RELEASE[ 	]*/ { print $$2 }' ${ROOTDIR}/${CONFIG_LINUXDIR}/include/linux/version.h|tail -n 1)
VERSION_CODE := $(shell awk '/[ 	]*\#[ 	]*define[ 	]*LINUX_VERSION_CODE[   ]*/ { print $$3 }' ${ROOTDIR}/${CONFIG_LINUXDIR}/include/linux/version.h|tail -n 1)
else
VERSION_CODE := 0
endif

CFLAGS = -fno-builtin -nostdinc -D__uClinux__ -D__KERNEL__ -I${ROOTDIR}/${CONFIG_LINUXDIR}/include -Wall -Wstrict-prototypes -Wno-trigraphs -O1 -fno-strict-aliasing -fno-common -I$(GCC_DIR)/include -pipe -DNO_MM -DNO_FPU $(CPUFLAGS) -Wa,-S -Wa,$(CPUFLAGS) -DUTS_SYSNAME="uClinux" -D__linux__ -DMODULE  -nostdinc -iwithprefix include
CFLAGS += -DFUSE_VERSION=\"2.2\"

CFLAGS += -I../include
CFLAGS += -D_FILE_OFFSET_BITS=64
CFLAGS += -DFUSE_USE_VERSION=22

LDFLAGS = -r

COMPOBJ = compat/parser.o

fuse.o: $(OBJS) $(COMPOBJ)
	# ugly way to set kernel version variables
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(COMPOBJ)

ifeq ($(shell if [ $(VERSION_CODE) -ge 132608 ]; then echo y; fi),y)
CFLAGS += -DKBUILD_MODNAME=fuse
OBJMOD = fuse.mod.o
else
# romptr not valid for 2.6.x
CFLAGS += -DMAGIC_ROM_PTR
OBJMOD = 
endif

fuse.ko: $(OBJS) $(OBJMOD)
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJMOD)

romfs:
	mkdir -p ${ROMFSDIR}/lib/modules/${RELEASE}
ifeq ($(shell if [ $(VERSION_CODE) -ge 132608 ]; then echo y; fi),y)
	$(ROMFSINST) /lib/modules/${RELEASE}/fuse.ko
else
	$(ROMFSINST) /lib/modules/${RELEASE}/fuse.o
endif

install:
	install -d $(INSTALLDIR)/lib/modules/$(RELEASE)
	install fuse.o $(INSTALLDIR)/lib/modules/$(RELEASE)/fuse.o

clean:
	rm -f $(EXECS) *~ *.gdb *.elf *.o *.ko *.s *.i $(COMPOBJ)

=== lib/Makefile ===

EXEC = libfuse.a
ifdef LIBFUSE_SHARED
EXEC += libfuse.gdb
endif

OBJS = fuse.o fuse_mt.o helper.o mount.o

all: $(EXEC)

CFLAGS += -I../include

libfuse.a: $(OBJS)
	rm -f libfuse.a
	$(CROSS)ar cr libfuse.a $(OBJS)
	$(CROSS)ranlib libfuse.a

libfuse.gdb: libfuse.a $(OBJS)
	rm -f libfuse.so*
	$(CROSS)gcc -o libfuse -g -nostartfiles \
		-mid-shared-library -mshared-library-id=0 \
		-Os -g -fomit-frame-pointer -m5200 -DCONFIG_COLDFIRE -fno-common -Wall  -Dlinux -D__linux__ -Dunix -D__uClinux__ -DEMBED -nostdinc -I$(ROOTDIR)/include -I$(ROOTDIR)/include/include -fno-builtin -Wl,-elf2flt -Wl,-move-rodata -nostartfiles $(ROOTDIR)/lib/crt0.o $(ROOTDIR)/lib/crti.o $(ROOTDIR)/lib/crtn.o  -L$(ROOTDIR)/lib \
		-Wl,-elf2flt -nostdlib \
		-mid-shared-library -mshared-library-id=$(LIBFUSE_ID) \
		-Wl,-shared-lib-id,$(LIBFUSE_ID) \
		-Wl,-R,$(ROOTDIR)/lib/libc.gdb \
		${ROOTDIR}/${CONFIG_LIBCDIR}/lib/main.o \
		-Wl,--whole-archive,libfuse.a,--no-whole-archive \
		-lc -lpthread -lgcc
	$(CROSS)objcopy \
		-L _GLOBAL_OFFSET_TABLE_ \
		-L main \
		-L __main \
		-L lib_main \
		-L __do_global_dtors \
		-L __do_global_ctors    \
		-L __CTOR_LIST__ \
		-L __DTOR_LIST__ \
		-L _current_shared_library_a5_offset_ \
		libfuse.gdb

romfs:
ifdef LIBFUSE_SHARED
	$(ROMFSINST) libfuse /lib/lib$(LIBFUSE_ID).so
endif

install:

clean:
	rm -f $(EXEC) *.gdb *.elf *.o *.s *.i

=== util/Makefile ===

EXECS = fusermount fusermount.static
OBJS = fusermount.o

all: $(EXECS)

CFLAGS += -I../include

FLTFLAGS += -s 32000

fusermount: $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LDLIBS)

fusermount.static: $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LDLIBS) -static

romfs:
	$(ROMFSINST) /usr/bin/fusermount

install:
	install -d $(INSTALLDIR)/usr/bin
	install fusermount $(INSTALLDIR)/usr/bin/fusermount
	install fusermount.static $(INSTALLDIR)/usr/bin/fusermount.static

clean:
	rm -f $(EXECS) *.gdb *.elf *.o
